package sun.java2d.loops;

import sun.java2d.SurfaceData;
import sun.java2d.SunGraphics2D;

public class DrawPolygons extends GraphicsPrimitive
{
    public static final String methodSignature;
    public static final int primTypeID;
    
    public static DrawPolygons locate(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return (DrawPolygons)GraphicsPrimitiveMgr.locate(DrawPolygons.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    protected DrawPolygons(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(DrawPolygons.methodSignature, DrawPolygons.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public DrawPolygons(long n, SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(n, DrawPolygons.methodSignature, DrawPolygons.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public native void DrawPolygons(SunGraphics2D p0, SurfaceData p1, int[] p2, int[] p3, int[] p4, int p5, int p6, int p7, boolean p8);
    
    @Override
    public GraphicsPrimitive makePrimitive(SurfaceType obj, CompositeType obj2, SurfaceType surfaceType) {
        throw new InternalError("DrawPolygons not implemented for " + obj + " with " + obj2);
    }
    
    @Override
    public GraphicsPrimitive traceWrap() {
        return new DrawPolygons.TraceDrawPolygons(this);
    }
    
    static {
        methodSignature = "DrawPolygons(...)".toString();
        primTypeID = GraphicsPrimitive.makePrimTypeID();
    }
    
    private static class TraceDrawPolygons extends DrawPolygons
    {
        DrawPolygons target;
        
        public TraceDrawPolygons(DrawPolygons target) {
            super(target.getSourceType(), target.getCompositeType(), target.getDestType());
            this.target = target;
        }
        
        @Override
        public GraphicsPrimitive traceWrap() {
            return this;
        }
        
        @Override
        public void DrawPolygons(SunGraphics2D sunGraphics2D, SurfaceData surfaceData, int[] array, int[] array2, int[] array3, int n, int n2, int n3, boolean b) {
            GraphicsPrimitive.tracePrimitive(this.target);
            this.target.DrawPolygons(sunGraphics2D, surfaceData, array, array2, array3, n, n2, n3, b);
        }
    }
}
